# derived from spec file by Laurent MONTEL <lmontel@mandrakesoft.com>

%define name pgcalc2
%define version 2.1
%define release 1

Summary: 	 Multifunction scientific skinable RPN calculator
Name: 		 %{name}
Version: 	 %{version}
Release: 	 %{release}
Source0: 	 %{name}-%{version}.tar.gz
License: 	 GPL
Group: 		 Utilities
BuildRoot: %{_tmppath}/%{name}-buildroot
URL: 		   http://www.pgcalc.net
Vendor:    Piotr Gridniew <gridniew@pgcalc.net>
Packager:  Piotr Gridniew <gridniew@pgcalc.net>

Requires: 	kdelibs

%description
PG Calculator is a powerfull scientific calculator and an excellent replacement for standard calculator. It ofers full customizable user inteface and looks like real calculator on user desktop. PG Calculator works in RPN mode. It recognizes real and complex numbers and allows vectors manipulations. There are up to 120 recognized units of measure with possibility to make ease conversions between consistent units. PG Calculator enables numbers inputing in binary, octal, hexadecimal and exponential formats. Up to 80 build-in functions: algebraic, trigonometry, hyperbolic, logical, numbers format convertions, units of measure conversions and statistical. 


%prep
rm -rf $RPM_BUILD_ROOT

%setup -q -n %name-%version

%build
export CFLAGS=$RPM_OPT_FLAGS
export CXXFLAGS=$RPM_OPT_FLAGS
# %%configure doesn't work
./configure --prefix=%_prefix \
	--bindir=%_bindir \
	--datadir=%_datadir \
  --disable-rpath \
	--disable-debug

%make

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall KDEDIR=$RPM_BUILD_ROOT%{_prefix} kde_minidir=$RPM_BUILD_ROOT%{_miconsdir}

#menu
mkdir -p $RPM_BUILD_ROOT%{_menudir}

# remove when building Mandrake RPM
 kdedesktop2mdkmenu.pl pgcalc2 "Applications/Utilities"    %buildroot/%_datadir/applnk/Utilities/pgcalc2.desktop                             %buildroot/%_menudir/pgcalc2

%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
# remove when building Mandrake RPM
	%{update_menus}

%postun
# remove when building Mandrake RPM
  %{clean_menus}

%files -f %name.lang
%defattr(-,root,root)
%doc README AUTHORS ChangeLog TODO COPYING
%doc %{_datadir}/doc/HTML/en/*
%_bindir/*
%_datadir/applnk/Utilities/pgcalc2.desktop

%dir %_datadir/apps/pgcalc2/
%_datadir/apps/pgcalc2/*.rc
#%_datadir/apps/pgcalc2/*.png
#%_datadir/apps/pgcalc2/*.jpg

%dir %_datadir/apps/pgcalc2/skins
%dir %_datadir/apps/pgcalc2/skins/default
%dir %_datadir/apps/pgcalc2/skins/Metallic
%dir %_datadir/apps/pgcalc2/skins/BHP49G
%_datadir/apps/pgcalc2/skins/default/*.bmp
%_datadir/apps/pgcalc2/skins/Metallic/*.bmp
%_datadir/apps/pgcalc2/skins/BHP49G/*.bmp
%_datadir/apps/pgcalc2/skins/default/skin.csk
%_datadir/apps/pgcalc2/skins/Metallic/skin.csk
%_datadir/apps/pgcalc2/skins/BHP49G/skin.csk


# remove when building Mandrake RPM
 %_menudir/*

%_datadir/icons/hicolor/32x32/apps/pgcalc2.png

