//#include <windows.h>
#include <astrings.h>

//---------------------------------------------------------------------------------
TStrings::TStrings( void )
//   : TObject( "TStrings" )
{
   FStrings = NULL;
   FCount = 0;
}
//---------------------------------------------------------------------------------
TStrings::~TStrings()
{
   Clear();
}
//---------------------------------------------------------------------------------
AnsiString TStrings::Text( void )
{
   AnsiString p = "";
   int j;
   
   for( j = 0; j < FCount; j++ )
   {
      p += ( *( FStrings[ j ] ) + AnsiString( "\n" ) );
   }
   return p;
}
//---------------------------------------------------------------------------------
void TStrings::Clear( void )
{
   if( FStrings && FCount )
   {
      int j;
      for( j = 0; j < FCount; j++ )
      {
         delete FStrings[ j ];
      }
      delete FStrings;
      FStrings = NULL;
      FCount = 0;
   }
}
//---------------------------------------------------------------------------------
void TStrings::Add( AnsiString AString )
{
   AnsiString** tmp;
   
   tmp = new AnsiString*[ FCount + 1 ];
   if( FStrings && FCount )
   {
      int j;
      for( j = 0; j < FCount; j++ )
      {
         tmp[ j ] = FStrings[ j ];
      }
      delete FStrings;
   }
   tmp[ FCount ] = new AnsiString( AString );
   FCount++;
   FStrings = tmp;
}
//---------------------------------------------------------------------------------
void TStrings::AddStrings( TStrings* AStrings )
{
   if( AStrings )
   {
      int j;
      
      for( j = 0; j < AStrings->Count(); j++ )
      {
         Add( AStrings->String( j ) );
      }
   }
}
//---------------------------------------------------------------------------------
void TStrings::Insert( int nIndex, AnsiString AString )
{
   if( FStrings && FCount && nIndex >= 0 && nIndex < FCount )
   {
      AnsiString** tmp;
      AnsiString msg;
      int j, i;
      
      tmp = new AnsiString*[ FCount + 1 ];
      for( j = 0, i = 0; j < FCount; j++ )
      {
         if( j == nIndex )
         {
            i++;
         }
         msg = *( FStrings[ j ] ) + ";j=" + IntToStr( j ) + ";i=" + IntToStr( i );
         //MessageBox( 0, msg.c_str(), "Inserting...", MB_OK );
         tmp[ j + i ] = FStrings[ j ];
      }
      delete FStrings;
      tmp[ nIndex ] = new AnsiString( AString );
      FCount++;
      FStrings = tmp;
   }
   else
   {
      Add( AString );
   }
}
//---------------------------------------------------------------------------------
void TStrings::Delete( int nIndex )
{
   if( FStrings && FCount && nIndex >= 0 && nIndex < FCount )
   {
      if( FCount == 1 && nIndex == 0 )
      {
         Clear();
      }
      else
      {
         AnsiString** tmp;
         int i, j;
         
         tmp = new AnsiString*[ FCount - 1 ];
         for( j = 0, i = 0; j < FCount; j++ )
         {
            if( j != nIndex )
            {
               tmp[ i ] = FStrings[ j ];
               i++;
            }
         }
         delete FStrings[ nIndex ];
         delete FStrings;
         
         FCount--;
         FStrings = tmp;
      }
   }
}
//---------------------------------------------------------------------------------
AnsiString TStrings::String( int nIndex )
{
   AnsiString p = "";
   if( FStrings && FCount && nIndex >= 0 && nIndex < FCount )
   {
      p = *( FStrings[ nIndex ] );
   }
   return p;
}
//---------------------------------------------------------------------------------
void TStrings::Replace( int nIndex, AnsiString Value )
{
   if( FStrings && FCount && nIndex >= 0 && nIndex < FCount )
   {
      *( FStrings[ nIndex ] ) = Value;
   }
}
//---------------------------------------------------------------------------------
int TStrings::Count( void )
{
   return FCount;
}
//---------------------------------------------------------------------------------
int TStrings::IndexOf( AnsiString AString )
{
   int j, index = -1;
   
   if( FStrings && FCount )
   {
      for( j = 0; j < FCount && index == -1; j++ )
      {
         if( *( FStrings[ j ] ) == AString )
         {
            index = j;
         }
      }
   }
   return index;
}
//---------------------------------------------------------------------------------

