#include "atomlist.h"
//------------------------------------------------------------------------------------------------
atomlist::atomlist( void )
{
   _atoms = NULL;
   _count = 0;
   //nullatom = new atom();
}
//------------------------------------------------------------------------------------------------
atomlist::~atomlist()
{
   clear();
}
//------------------------------------------------------------------------------------------------
void atomlist::clear( void )
{
   if( _atoms && _count )
   {
      int j;
      
      for( j = 0; j < _count; j++ )
      {
         delete _atoms[ j ];
      }
      delete [] _atoms;
      _atoms = NULL;
      _count = 0;
   }
}
//------------------------------------------------------------------------------------------------
void atomlist::addatom( atom* a, const char* name )
{
   atom** tmp;
   int j;

   if( !a )
   {
      return;
   }

   tmp = new atom*[ _count + 1 ];
   if( _atoms && _count )
   {
      for( j = 0; j < _count; j++ )
      {
         tmp[ j ] = _atoms[ j ];
      }
      delete [] _atoms;
   }

   if( name )
   {
      a->setname( name );
   }
   tmp[ _count ] = a;
   _count++;
   _atoms = tmp;
}
//------------------------------------------------------------------------------------------------
void atomlist::delatom( int index )
{
   atom** tmp;
   int i, j;

   if( index >= 0 && index < _count )
   {
      if( _count > 1 )
      {
         clear();
      }
      else
      {
         tmp = new atom*[ _count - 1 ];
         for( j = 0, i = 0; j < _count; j++ )
         {
            if( j != index )
            {
               tmp[ i ] = _atoms[ j ];
               i++;
            }
         }
         delete [] _atoms;
         _atoms = tmp;
         _count--;
      }
   }
}
//------------------------------------------------------------------------------------------------
atom& atomlist::operator[]( int index )
{
   if( index >= 0 && index < _count && _atoms )
   {
      return *( _atoms[ index ] );
   }
   else
   {
      return nullatom;
   }
}
//------------------------------------------------------------------------------------------------
atom& atomlist::getAtom( int index )
{
   if( index >= 0 && index < _count && _atoms )
   {
      return *( _atoms[ index ] );
   }
   else
   {
      return nullatom;
   }
}
//------------------------------------------------------------------------------------------------
atom& atomlist::atomByName( const char* name )
{
   int index;

   index = findAtom( name );
   if( index != -1 )
   {
      return *( _atoms[ index ] );
   }
   return nullatom;
}
//------------------------------------------------------------------------------------------------
int atomlist::findAtom( const char* name )
{
   int j;
   int index = -1;

   if( name )
   {
      for( j = 0; j < _count && index == -1; j++ )
      {
         if( strcmp( name, _atoms[ j ]->name() ) == 0 )
         {
            index = j;
         }
      }
   }
   return index;
}
//------------------------------------------------------------------------------------------------

